<?php

require_once('settingsGui.php');

function killApp()
{
  global $recfeeds;
  $first_line = true;

  gtk::main_quit();
  saveSettings();

  $fh = fopen('feeds.txt', 'w');
  foreach($recfeeds as $feed)
  {
    if (!$first_line)
      fwrite($fh, "\n");
    fwrite($fh, $feed);
    $first_line = false;
  }
  fclose($fh);
}

function killWidget($source, $target)
{
  $target->destroy();
}

function entryMenuClicked($widget, $data)
{
  list($target, $operation) = $data;

  $target->select_region(0, -1);

  switch ($operation)
  {
    case 'cut':
      $target->cut_clipboard();
      break;
    case 'copy':
      $target->copy_clipboard();
      break;
    case 'paste':
      $target->paste_clipboard();
      break;
  }
}

function treeItemMenuClicked($widget, $data)
{
  global $recfeeds;
  list($user_data, $action) = $data;

  switch ($action)
  {
    case 'desc':
      alert($user_data, 'Item Description', false);
      break;
    case 'oplink':
      passthru("\"" . getSetting('http-client') . "\" " . $user_data);
      break;
    case 'subsc':
      $line = $recfeeds[$user_data];
      list($name, $addr, $subscribed) = explode(',', $line);
      $subscribed = true;
      $recfeeds[$user_data] = $name . ',' . $addr . ',' . $subscribed;
      break;
  }
}

function createEditMenu($widget, $event)
{
  $editMenu = &new GtkMenu();

  $cutItem = &new GtkMenuItem('Cut');
  $cutItem->connect('activate', 'entryMenuClicked', array($widget, 'cut'));

  $copyItem = &new GtkMenuItem('Copy');
  $copyItem->connect('activate', 'entryMenuClicked', array($widget, 'copy'));

  $pasteItem = &new GtkMenuItem('Paste');
  $pasteItem->connect('activate', 'entryMenuClicked', array($widget, 'paste'));

  $editMenu->append($cutItem);
  $editMenu->append($copyItem);
  $editMenu->append($pasteItem);
  $editMenu->show_all();

  $editMenu->popup(null, null, null, 0, $event->time);
}

function createTreeItemMenu($widget, $event, $data)
{
  list($arb, $tlm) = $data;
  $tiMenu = &new GtkMenu();

  if (isset($arb['description']))
  {
    $descItem = &new GtkMenuItem('View Description...');
    $descItem->connect('activate', 'treeItemMenuClicked', array($arb['description'], 'desc'));
    $tiMenu->append($descItem);
  }

  if (isset($arb['link']))
  {
    $oplinkItem = &new GtkMenuItem('Go to link target...');
    $oplinkItem->connect('activate', 'treeItemMenuClicked', array($arb['link'], 'oplink'));
    $tiMenu->append($oplinkItem);
  }

  if (isset($arb['title']) && $tlm)
  {
    $subscItem = &new GtkMenuItem('Subscribe to this feed...');
    $subscItem->connect('activate', 'treeItemMenuClicked', array($arb['title'], 'subsc'));
    $tiMenu->append($subscItem);
  }

  $tiMenu->show_all();

  if ($tiMenu->children())
    $tiMenu->popup(null, null, null, 0, $event->time);
}

function entryClicked($widget, $event)
{ 
  if ($event->button == 3)
    createEditMenu($widget, $event);
}

function entryPressed($widget, $event)
{
  if ($event->keyval == GDK_KEY_F10 && $event->state == GDK_SHIFT_MASK)
    createEditMenu($widget, $event);
}

function showInfo()
{
  alert("RSS 3.0 Reader (R3R)\n\n" . 'Version: ' . VERSION . "\nOperating System: " . getOS() . "\nPHP Version: " . PHP_VERSION . "\nPHP API: " . php_sapi_name(), 'About R3R...');
}

function treeItemClicked($widget, $event, $data)
{
  if ($event->button == 3)
    createTreeItemMenu($widget, $event, $data);
}

function treeItemPressed($widget, $event, $data)
{
  if ($event->keyval == GDK_KEY_F10 && $event->state == GDK_SHIFT_MASK)
    createTreeItemMenu($widget, $event, $data);
}

function expandFeed($widget)
{
  static $can_expand = true;

  if ($can_expand)
    $widget->expand();
  else
    $widget->collapse();

  $can_expand = !$can_expand;
}

function goBtnClicked($widget, $data)
{
  getRemoteFeed($data->get_text());
}

function urlFieldGo($widget, $event, $data)
{
  if ($event->keyval == GDK_KEY_Return)
    goBtnClicked($data, $widget);
}

function settingsDlgDel($widget, $data)
{
  list($save_settings, $settings) = $data;

  if ($save_settings)
    cancelSettingsChange($widget, $settings);
}

function cancelSettingsChange($widget, $data)
{
  global $settings;

  $settings = $data;
}

function checkToggled($source, $data)
{
  list($targets, $setting) = $data;

  $sensitive = !getSetting($setting);
  foreach ($targets as $target)
    $target->set_sensitive($sensitive);
  setSetting($setting, $sensitive);
}

function settingsEntryChanged($widget, $data)
{
  setSetting($data, $widget->get_text());
}

?>