<?php

function alert($msg, $title = 'Error', $wrap = true)
{
  $alertWindow = &new GtkWindow(GTK_WINDOW_DIALOG);
  $alertWindow->set_title($title);
  $alertWindow->set_policy(false, false, true);
  $alertWindow->show();

  $alertBox = &new GtkVBox();
  $alertWindow->add($alertBox);

  $label = &new GtkLabel();
  $label->set_line_wrap($wrap);
  $label->set_text($msg);
  $alertBox->pack_start($label, false, false, 5);

  $okBtnBox = &new GtkHButtonBox();
  $alertBox->pack_start($okBtnBox);

  $OKButton = &new GtkButton('OK');
  $OKButton->set_usize(30, 30);
  $OKButton->connect('clicked', 'killWidget', $alertWindow);
  $okBtnBox->pack_start($OKButton, false, false, 5);

  $OKButton->set_flags(GTK_CAN_DEFAULT);
  $OKButton->grab_default();

  $alertWindow->show_all();
}

function createEdit($text = '')
{
  global $window;

  $entry = &new GtkEntry();
  $entry->set_text($text);
  $entry->connect('key-press-event', 'entryPressed');
  $entry->connect('button-release-event', 'entryClicked');
  return $entry;
}

function updateSelectionField($source, $data)
{
  list($fileSel, $entry) = $data;
  $entry->set_text($fileSel->get_filename());
}

function createFileSelection($source, $data)
{
  list($target, $title, $setting, $entry) = $data;

  $fileSel = &new GtkFileSelection($title);
  $fileSel->set_filename(getSetting($setting));

  $selEntry = $fileSel->selection_entry;
  $selEntry->connect('button-release-event', 'entryClicked');
  $selEntry->connect('key-press-event', 'entryPressed');

  $okBtn = $fileSel->ok_button;
  $okBtn->connect('clicked', 'updateSelectionField', array($fileSel, $target));
  $okBtn->connect('clicked', 'killWidget', $fileSel);

  $cancelBtn = $fileSel->cancel_button;
  $cancelBtn->connect('clicked', 'killWidget', $fileSel);

  $fileSel->show();
}

function createAccelMenu($label = '', $mask = 4)
{
  global $accelGroup;

  $menuItem = &new GtkMenuItem('');
  $menuLabel = $menuItem->child;
  $menuItem->add_accelerator('activate', $accelGroup, $menuLabel->parse_uline($label), $mask, GTK_ACCEL_VISIBLE);
  return $menuItem;
}

function getKnownFeeds()
{
  global $recfeeds;

  $knownFeeds = array('http://');
  $file_array = file('feeds.txt');
  $file_lines = count($file_array);

  for ($idx = 0; $idx < $file_lines; $idx++)
  {
    $file_array[$idx] = trim($file_array[$idx]);
    list($name, $addr, $subscribed) = explode(',', $file_array[$idx]);
    $url = trim(urldecode($addr));
    $recfeeds[urldecode($name)] = $file_array[$idx];
    if ($subscribed)
      getRemoteFeed($url);
    $knownFeeds[$idx + 1] = $url;
  }

  return $knownFeeds;
}

?>