<?php

require_once('guiConvFuncs.php');
require_once('callbacks.php');
require_once('r3parser.php');

function createWindow()
{
  global $box, $window;

  $window->set_title('R3R');
  $window->set_policy(false, false, true);
  $window->connect('destroy', 'killApp');

  $window->add($box);
}

function createMenu()
{
  global $box, $menuBar;

  $box->pack_start($menuBar, true, false);

  $fileMenu = &new GtkMenu();
  $toolsMenu = &new GtkMenu();
  $helpMenu = &new GtkMenu();

  $fileMenuItem = createAccelMenu('_File', 8);

  $quitItem = createAccelMenu('_Quit');
  $quitItem->connect('activate', 'killApp');

  $toolsMenuItem = createAccelMenu('_Tools', 8);

  $settingsItem = createAccelMenu('_Settings...');
  $settingsItem->connect('activate', 'showSettingsDialog');

  $saveSettingsItem = createAccelMenu('S_ave Settings');
  $saveSettingsItem->connect('activate', 'saveSettings');

  $helpMenuItem = createAccelMenu('_Help', 8);
  $helpMenuItem->right_justify();

  $infoItem = createAccelMenu('_Info...');
  $infoItem->connect('activate', 'showInfo');

  $menuBar->append($fileMenuItem);
  $menuBar->append($toolsMenuItem);
  $menuBar->append($helpMenuItem);

  $fileMenu->append($quitItem);

  $toolsMenu->append($settingsItem);
  $toolsMenu->append($saveSettingsItem);

  $helpMenu->append($infoItem);

  $fileMenuItem->set_submenu($fileMenu);
  $toolsMenuItem->set_submenu($toolsMenu);
  $helpMenuItem->set_submenu($helpMenu);
}

function createAppArea()
{
  global $box, $feedTree, $statusBar;

  $feedTree->show();

  $scroll = &new GtkScrolledWindow();
  $scroll->set_usize(400, 100);
  $scroll->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
  $scroll->add_with_viewport($feedTree);
  $box->pack_start($scroll, false, false);
  $scroll->show();

  $addrBox = &new GtkHBox(false);
  $box->pack_start($addrBox, false, false, 5);

  $urlCombo = &new GtkCombo();
  $urlCombo->disable_activate();
  $urlCombo->set_popdown_strings(getKnownFeeds());
  $addrBox->pack_start($urlCombo, true, true, 5);

  $urlCombo_entry = $urlCombo->entry;
  $urlCombo_entry->connect('button-release-event', 'entryClicked');
  $urlCombo_entry->connect('key-press-event', 'entryPressed');

  $goBtn = &new GtkButton('Go');
  $goBtn->connect('clicked', 'goBtnClicked', $urlCombo_entry);
  $addrBox->pack_start($goBtn, false, false, 5);
  $urlCombo_entry->connect('key-press-event', 'urlFieldGo', $goBtn);

  $box->pack_start($statusBar);
}

function startMainGui()
{
  global $accelGroup, $argc, $argv, $window;

  getSettings();

  if (getSetting('use-rc-file'))
    gtk::rc_parse(getSetting('rc-file'));

  createWindow();
  createMenu();
  createAppArea();

  for ($idx = 1; $idx < $argc; $idx++)
    getRemoteFeed(rawurldecode($argv[$idx]));

  $window->add_accel_group($accelGroup);
  $window->show_all();
  gtk::main();
}

?>