<?php

function setSetting($setting_name, $setting_val)
{
  global $settings;

  $settings[$setting_name] = $setting_val;
}

function getSetting($setting_name)
{
  global $settings;

  if (empty($settings[$setting_name]))
    return false;
  else
  {
    $str = $settings[$setting_name];
    if (strpos($str, '{const:') >= 0)
    {
      $ptrn = '/\{const\:(\w+)\}/';
      preg_match_all($ptrn, $str, $matches, PREG_SET_ORDER);

      foreach ($matches as $match)
        $str = preg_replace($ptrn, constant($match[1]), $str, 1);
    }
    if (strpos($str, '{func:') >= 0)
    {
      $ptrn = '/\{func\:(\w+)\}/';
      preg_match_all($ptrn, $str, $matches, PREG_SET_ORDER);

      foreach ($matches as $match)
        $str = preg_replace($ptrn, $match[1](), $str, 1);
    }
    return $str;
  }
}

function setInitialSettings()
{
  setSetting('accept-types', 'text/x-rss, text/plain; q=0.5; text/*; q=0.4, */*; q=0.1');
  setSetting('http-client', 'mozilla');
  setSetting('proxy-addr', '0.0.0.0');
  setSetting('proxy-port', 8080);
  setSetting('rc-file', '');
  setSetting('timeout-sec', 30);
  setSetting('use-proxy', false);
  setSetting('use-rc-file', false);
  setSetting('user-agent', 'R3R/{const:VERSION} ({func:getOS}) PHP/{const:PHP_VERSION} ({func:php_sapi_name})');
}

function getSettings()
{
  chdir('settings');
  if (!file_exists(SETTINGS_FILE))
    setInitialSettings();
  else
  {
    $fh = fopen(SETTINGS_FILE, 'r');
    while (!feof($fh))
    {
      list($setting_name, $setting_val) = explode(',', fgets($fh));
      setSetting($setting_name, trim(rawurldecode($setting_val)));
    }
    fclose($fh);
  } 
  chdir('..');
}

function saveSettings()
{
  global $settings;
  reset($settings);

  $first_line = true;

  chdir('settings');
  if (file_exists(SETTINGS_FILE))
    chmod(SETTINGS_FILE, 0600);
  $fh = fopen(SETTINGS_FILE, 'w');

  while (list($setting_name, $setting_val) = each($settings))
  {
    if (!$first_line)
      fwrite($fh, "\n");
    fwrite($fh, $setting_name . ',' . rawurlencode($setting_val));
    $first_line = false;
  }

  fclose($fh);
  chmod(SETTINGS_FILE, 0400);
  chdir('..');
}

?>